{% extends "base.html" %}
{% import "macros.html" as macros %}

{% block class %}app{% endblock class %}
{% block title %}{{ app.name }} – {{ "Apps for GNOME"|t }}{% endblock title %}

{% block head %}
    {# <link rel="canonical" href="{{ absolute_base_url }}/{{ lang_url_part }}{{ logical_url }}" /> #}

    {% set abstract = app.description.clone()|replace("</p>", " </p>")|striptags|truncate(200) %}

    {% call macros::cards(
        app.name,
        "{} – {}"|format(app.summary, abstract),
        "{}/icons/128/{}.png"|format(site.absolute_base_url, app.id),
        "{}/icons/twitter/{}.png"|format(site.absolute_base_url, app.id),
        app.brand_color_light
       )
    %}

    <link rel="stylesheet" href="{{ site.assets_url }}/slick/slick.css"/>
    <link rel="stylesheet" href="{{ site.assets_url }}/slick/slick-theme.css"/>

    <link rel="icon" sizes="16x16" href="{{ site.base_url }}/icons/16/{{ app.id }}-light.png">
    <link rel="icon" sizes="32x32" href="{{ site.base_url }}/icons/32/{{ app.id }}-light.png">
    <link rel="icon" sizes="64x64" href="{{ site.base_url }}/icons/64/{{ app.id }}.png">
    <link rel="icon" sizes="128x128" href="{{ site.base_url }}/icons/128/{{ app.id }}.png">
{% endblock head %}

{% block header %}
{% endblock header %}

{% block content %}
    <style>
        body {
            --primary-color: {{ app.brand_color_light }};
            --secondary-color: {{ app.text_color_light }};

            --primary-color-variant-1: var(--primary-color);
            --primary-color-variant-2: var(--primary-color);
        }

        @supports (color: hsl(from red h s calc(l + 1))) {
          body {
            --primary-color-variant-1: hsl(from var(--primary-color) h s calc(l + 6));
            --primary-color-variant-2: hsl(from var(--primary-color) h s calc(l - 3));
          }
        }

        @media (prefers-color-scheme: dark) {
            body {
              --primary-color: {{ app.brand_color_dark }};
              --secondary-color: {{ app.text_color_dark }};
            }
        }
    </style>

    <div itemscope itemtype="https://schema.org/SoftwareApplication">

    <header class="app">
            <div class="bar">
                <a class="logo" href="{{ site.lang_base_url }}/#{{ app.gnome }}" title="{{ "Overview"|t }}">
                    {%- if app.gnome == "circle" -%}
                        {% include "svg/circle.svg" %}
                    {%- else -%}
                        {% include "svg/gnome.svg" %}
                    {%- endif -%}
                </a>

                <nav>
                    <ul>
                        <li><a href="{{ site.lang_base_url }}/">{{ "Apps for GNOME"|t }}</a></li>
                        <li>
                            <a onclick="selectLanguage(); return false" href="#" title="{{ "Switch Language"|t }}">
                                {% call macros::svg_icon("translate") %}
                            </a>
                        </li>
                    </ul>
                </nav>
            </div>

        <div class="banderole">
            <div>
                <img itemprop="thumbnailUrl image" width="128" height="128" src="{{ site.base_url }}/icons/scalable/{{ app.id }}.svg" alt="" role="presentation" />
            </div>
            <h1 itemprop="name">{{ app.name }}</h1>
        </div>
    </header>

    <section dir="auto" class="small">

        <h3 itemprop="disambiguatingDescription">{{ app.summary }}</h3>

        <div itemprop="description">
            {{ app.description|safe }}
        </div>
    </section>

    <section dir="auto">
        <h2>{{ "Get involved"|tc("App details section headings") }}</h2>

        <div class="hull">
            <div class="buttons">
                {% if app.on_flathub %}
                {% call macros::info_box(
                    "Get the app"|t,
                    "Install the latest version from Flathub."|t,
                    "download",
                    "https://flathub.org/apps/details/{}"|format(app.id),
                    "itemprop='installUrl'"
                ) %}
                {% endif %}

                {% call macros::info_box(
                  "Contribute"|t,
                  "Learn how you can contribute to this app."|t,
                  "welcome",
                  "https://welcome.gnome.org/app/{}/"|format(app.page_id),
                  ""
                ) %}

                {% call macros::link_box("Give feedback"|t, "Contribute your ideas or report issues on the app’s issue tracker."|t, "bug_tracker", app.url_bugtracker) %}

                {% match app.url_contact %}
                  {% when Some with (url) %}
                    {% if url|is_containing("matrix.to") %}
                      {% call macros::link_box("Get in touch"|t, "Just chat with the app's community or get help when you are stuck."|t, "contact", app.url_contact) %}
                    {% else %}
                      {% call macros::link_box("Get in touch"|t,  "Learn how you can contact the project."|t, "contact", app.url_contact) %}
                    {% endif %}
                  {% when None %}
                {% endmatch %}

                {% call macros::link_box( "Help translating"|t, "Help translate this app into your language."|t, "translate", app.url_translate) %}

                {% match app.url_donation %}
                {% when Some with (url) %}
                  {% if url|is_containing("//www.gnome.org") %}
                    {% call macros::link_box("Donate money"|t, "Donate to the GNOME Foundation to support this project."|t, "donation", app.url_donation) %}
                  {% else %}
                    {% call macros::link_box("Donate money"|t, "Learn how you can donate to the developers of this project."|t, "donation", app.url_donation) %}
                  {% endif %}
                {% when None %}
              {% endmatch %}
            </div>
        </div>
    </section>

    {% if app.screenshots_light|is_not_empty %}
    <section dir="auto" id="screenshots">
    <h2>{{ "Explore the interface"|tc("App details section headings") }}</h2>
        <script>
          screenshotFilterInit = '.light';
        </script>

        <div class="screenshots">
        {% for screenshot in app.screenshots_light %}
            <figure class="light">
                <img itemprop="screenshot" src="{{ site.assets_url }}/screenshots/{{ app.id }}/{{ screenshot.file }}" alt="" />

            {% if screenshot.caption|is_not_empty %}
                <figcaption>{{ screenshot.caption }}</figcaption>
            {% endif %}
            </figure>
        {% endfor %}

        {% match app.screenshots_dark %}
        {% when Some with (screenshots) %}
          <script>
            var darkModeMediaQueryScreenshot = window.matchMedia('(prefers-color-scheme: dark)');
            darkModeMediaQueryScreenshot.addEventListener('change', handleScreenshotDarkmode);

            screenshotFilterInit = darkModeMediaQueryScreenshot.matches ? '.dark' : '.light';

            function handleScreenshotDarkmode(e) {
              var dark_mode = e.matches;

              $('.screenshots').slick('slickUnfilter');
              if (dark_mode) {
                $('.screenshots').slick('slickFilter', '.dark');
              } else {
                $('.screenshots').slick('slickFilter', '.light');
              }
            }
          </script>
          {% for screenshot in screenshots %}
          <figure class="dark">
            <img itemprop="screenshot" src="{{ site.assets_url }}/screenshots/{{ app.id }}/{{ screenshot.file }}" alt="" />

            {% if screenshot.caption|is_not_empty %}
            <figcaption>{{ screenshot.caption }}</figcaption>
            {% endif %}
          </figure>
          {% endfor %}
        {% when None %}
        {% endmatch %}
        </div>


    </section>
    {% endif %}

    {% if app.members|is_not_empty %}
    <section dir="auto">
    <h2>{{ "Get to know us"|tc("App details section heading") }}</h2>
    <ul class="people">
    {% for maintainer in app.members %}
        <li itemprop="maintainer" itemscope itemtype="https://schema.org/Person">
            <img src="{{ maintainer.avatar_url|option_to_string }}" alt="" />
            <div>
                <div class="badge">{{ "Maintainer"|t }}</div>
                <h4 dir="auto" itemprop="name">{{ maintainer.name|option_to_string }}</h4>
                {% if maintainer.pronouns|is_not_empty %}
                <div dir="auto" class="pronouns">
                    {{ maintainer.pronouns|option_to_string }}
                </div>
                {% endif %}
                <ul>
                  {% if maintainer.location|is_not_empty %}
                    <li>
                      <img src="{{ site.assets_url }}/location.svg" alt="" role="presentation" />
                      <span>{{ maintainer.location|option_to_string }}</span>
                    </li>
                  {% endif %}
                  {% for git_account in maintainer.git_accounts %}
                    <li>
                    {% set link_title = "" %}
                    {% if git_account.url.contains("github.com/") %}
                        <img src="{{ site.assets_url }}/github.svg" alt="" role="presentation" />
                        {% set link_title = "GitHub account"|t %}
                    {% else %}
                        <img src="{{ site.assets_url }}/gitlab.svg" alt="" role="presentation" />
                      {% set link_title = "GitLab account"|t %}
                    {% endif %}
                        <a dir="auto" href="{{ git_account.url }}" title="{{ link_title }}">@{{ git_account.username }}</a>
                    </li>
                  {% endfor %}
                  {% for social in maintainer.social_accounts %}
                    <li>
                        <img src="{{ site.assets_url }}/social-{{social.provider}}.svg" alt="" role="presentation" />
                        <a dir="auto" href="{{ social.url }}" title="{{ "{} account"|tc("The {} will be replaced with a social media name like 'Mastodon'")|f([social.provider.as_str()]) }}">
                          {{ social.display }}
                        </a>
                    </li>
                  {% endfor %}
                  {% for website in maintainer.websites %}
                    <li>
                      <img src="{{ site.assets_url }}/website.svg" alt="" role="presentation" />
                      <a dir="auto" href="{{ website }}">{{ "Website"|t }}</a>
                    </li>
                  {% endfor %}
                </ul>
            </div>
        </li>
    {% endfor %}
    </ul>
    </section>
    {% endif %}

    <section dir="auto">
    <h2>{{ "More Information"|tc("App details section heading") }}</h2>

    <div class="hull">
    <div class="buttons">
        {% call macros::link_box("Learn more"|t, "Visit the online help page for this app."|t, "help", app.url_help) %}
        {% call macros::link_box("Project homepage"|t, "Visit the dedicated homepage for this project."|t, "homepage", app.url_homepage) %}

        {% match app.stable_releases().first() %}
          {% when Some with (release) %}

        {% set version_name = "<span itemprop='version softwareVersion'>{}</span>"|format(release.version) %}
        {% set release_text = "Latest version { version_name } released on { date }."|tc("This is a template string. You can move a pair of curly braces with the keyword in between around. But do not change or translate the keyword in between the braces.")|replace("{ version_name }", version_name)|replace("{ date }", release.locale_date|option_to_string) %}

        {% call macros::info_box(
            "Newest Release"|t,
            release_text|safe,
            "release",
            "",
            ""
        ) %}
          {% when None %}
        {% endmatch %}

        {% if site.document_language != "en" %}
            {% set header %}
            {% set text %}

            {% match app|select_language(site.document_language) %}
            {% when Some with (language) %}
                {% if language.percentage >= Some(70) %}
                    {%- set header = "App is translated"|t -%}
                    {%- set text = "This app is available in your language."|t -%}
                {% else if language.percentage >= Some(40) %}
                    {%- set header = "Partially translated"|t -%}
                    {%- set text = "Some parts of this app are available in your language."|t -%}
                {% else %}
                    {%- set header = "Sparsely translated"|t -%}
                    {%- set text = "Only a small part of this app is available in your language."|t -%}
                {% endif %}
            {% when None %}
                {%- set header = "Not translated"|t -%}
                {%- set text = "This app is not available in your language."|t -%}
            {% endmatch %}

            {% call macros::info_box(header, text, "translate", "", "") %}
      {% endif %}

    </div>
    </div>

    <h3>{{ "Keywords"|t }}</h3>

    <ul class="keywords">
    {% for keyword in app.keyword_collection %}
      {% if keyword == "Linux" %}
      <li dir="auto" itemprop="operatingSystem">{{ keyword }}</li>
      {% else %}
      <li dir="auto" itemprop="keywords">{{ keyword }}</li>
      {% endif %}
    {% endfor %}
    </ul>

    </section>
    </div>

    <script type="text/javascript" src="https://code.jquery.com/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="https:////code.jquery.com/jquery-migrate-1.2.1.min.js"></script>
    <script type="text/javascript" src="{{ site.assets_url }}/slick/slick.min.js"></script>

    <script type="text/javascript">
        $(document).ready(function() {
            screenshots = document.getElementById("screenshots");
            direction = getComputedStyle(screenshots).direction;
            $('.screenshots').slick({
                "autoplay": true,
                "autoplaySpeed": 6000,
                "dots": true,
                "touchThreshold": 6,
                "speed": 600,
                "waitForAnimate": false,
                "rtl": direction == "rtl",
            });
            $('.screenshots').slick('slickUnfilter');
            $('.screenshots').slick('slickFilter', screenshotFilterInit);
            screenshots.setAttribute("dir", direction);
        });


    </script>

{% endblock content %}

{% block copyright %}
    {%- set license -%}
    {%- if app.metadata_license|is_not_empty -%}
        {%- set license = app.metadata_license.clone() -%}
    {%- else -%}
        {%- set license = app.project_license.clone() -%}
    {%- endif -%}

    <div>
        {{ "App specific content © The respective app contributors"|t }}
        ({{ license }})
    </div>
{% endblock copyright %}
